#include<iostream.h>
#include<math.h>
#include<dpmi.h>

double s[256];
double c[256];
int q [8][3]=
{
{-50,-50,-50}, {-50,-50,50}, {-50,50,-50}, {-50,50,50},
{50,-50,-50},  {50,-50,50},  {50,50,-50},  {50,50,50}
};
int arrete [12][2]=
{
  {0,1},{0,2},{0,4},{3,1},{3,2},{3,7},{5,1},{5,4},{5,7},{6,2},{6,4},{6,7}
};

void inter(int ,int,int,int,int);// num, ax,bx,cx,dx
void project();
void init_cos_sin();
void transform();
void transform(int,int,int,int,int,int,int,int,int);


void main()
{


init_cos_sin();
inter(0x10,0x13,0,0,0); //vga
//****************************************************************** <---- !!
int i;
for (i=1;i!=60;i++)
{
transform(1,1,1,4,3,2,0,0,0);
project();
//inter(0x21,0x800,0,0,0);
}
inter(0x21,0x800,0,0,0);
inter(0x10,3,0,0,0);    //txt
}

void init_cos_sin()
{
cout<<endl<<"* INITIALISATION DES TABLES DE SINUS - COSINUS \n";
double A=0;
int i;
for (i=0;i!=256;i++)
  {
    s[i]=sin(A);
    c[i]=cos(A);
    A+=PI/256;
    if (i%4==0) cout<<".";
   }
cout<<endl;
}

void transform(int hx,int hy,int hz,int ax,int ay,int az,int tx,int  ty,int tz)
{  //h=homotetie(taille)
double m[4][4];
//cout<<c[0]<<" "<<s[0]<<endl;;
m[0][3]=0;
m[1][3]=0;
m[2][3]=0;
m[3][3]=1;

m[0][0]=c[ay]*c[az]*hx;                        // 1
m[0][1]=c[ay]*s[az]*hy;                        // 0
m[0][2]=-(s[ay])   *hz;                        // 0
m[1][0]=(s[ax]*s[ay]*c[az] - c[ax]*s[az])*hx;  // 0
m[1][1]=(s[ax]*s[ay]*s[az] + c[ax]*c[az])*hy;  // 1
m[1][2]=s[ax]*c[ay] *hz;                       // 0
m[2][0]=(c[ax]*s[ay]*c[az] + s[ax]*s[az])*hx;  // 0
m[2][1]=(c[ax]*s[ay]*s[az] - s[ax]*c[az])*hy;  //-1
m[2][2]=c[ax]*c[ay]*hz;                        // 1
m[3][0]=hx*tx;                                 // 0
m[3][1]=hy*ty;                                 // 0
m[3][2]=hz*tz;                                 // 0
//  fin de la matrice de transformation : translation/rotation/homotetie
int i;
double t0,t1,t2;
for (i=0;i<=7;i++)
  { //
  //cout<<q[i][0]<<" "<<q[i][1]<<" "<<q[i][2]<<endl;
              // 0                0               0
  t0=m[0][0]*q[i][0]+m[1][0]*q[i][1]+m[2][0]*q[i][2]+m[3][0];
  t1=m[0][1]*q[i][0]+m[1][1]*q[i][1]+m[2][1]*q[i][2]+m[3][1];
  t2=m[0][2]*q[i][0]+m[1][2]*q[i][1]+m[2][2]*q[i][2]+m[3][2];
  q[i][0]=t0;
  q[i][1]=t1;
  q[i][2]=t2;

   //cout<<q[i][0]<<" "<<q[i][1]<<" "<<q[i][2]<<endl;
   }
//cout<<endl;
}

void project()
{
int x,y,i,col=2;
for (i=0;i<=7;i++)
{
  x=160+q[i][0] ;
  y=100+q[i][1] ;
  inter(0x10,0x0c00+col,0,x,y);  // point jaune(14)
col++;
}
}

void inter(int num, int ax, int bx, int cx, int dx)
{
__dpmi_regs r;
r.x.ax=ax;
r.x.bx=bx;
r.x.cx=cx;
r.x.dx=dx;
__dpmi_int(num,&r);
}


